#include <stdio.h>
#include <stdlib.h>

struct atomo {
       int dato;
       struct atomo *next;
       };
       
int test_lista_vuota(struct atomo *tlista)
{
    if(tlista==NULL)
       return 1;
    else return 0;
}


int testa_lista(struct atomo *tlista)
{ /* da invocare solo dopo avere verificato che la lista
    non e' vuota*/
    
    return (*tlista).dato;
    /* oppure 
    return tlista->dato;
    */
}

void in_lista(struct atomo **ptlista, int x)
{
     struct atomo *aux;
     
     /* creazione del nuovo elemento*/
     aux=(struct atomo *) malloc(sizeof(struct atomo));
     if(aux==NULL)
      return;
     aux->dato=x;
     
     /* collegamento del nuovo elemento al vecchio
        primo elemento */
     aux->next=*ptlista;
     /* aggiornamento dell'indirizzo del primo elemento*/
     *ptlista=aux;
}


void da_lista(struct atomo **ptlista)
{
     struct atomo *aux;
     
     if(test_lista_vuota(*ptlista)==0)
     /* se la lista non e' vuota*/
     {
      /* memorizziamo l'indizizzo dell'elemento
        in testa da eliminare */
      aux=*ptlista;
      /* aggiorniamo l'indirizzo del primo elemento*/
      *ptlista=aux->next;
      /* liberiamo la memoria del vecchio primo elemento*/
      free(aux);
     }
   else printf("Lista vuota\n");
}

void visualizza(struct atomo *tlista)
{
     struct atomo *aux;
     
     aux=tlista;
     while(aux!=NULL)
     /* fino a quando non siamo arrivati
         alla fine della lista */
     { printf("%d\n",aux->dato);
       aux=aux->next;
     }
}

main() {

  struct atomo *tlista;
  int scelta,x;
  
  
  tlista=NULL;
  
  do {
   printf("Scegli tra\n");
   printf("1) test lista vuota\n");
   printf("2) testa lista\n");
   printf("3) inserimento in testa\n");
   printf("4) eliminazione dalla testa\n");
   printf("5) visualizzazione lista\n");
   printf("0) fine\n");
   scanf("%d",&scelta);
   switch(scelta) {
     case 1:  if(test_lista_vuota(tlista)==1)
                      printf("Lista vuota\n");
              else  printf("Lista non vuota\n");
              break;
     case 2:  if(test_lista_vuota(tlista)==0)
              /* se la lista non e' vuota*/
                 printf("%d\n",testa_lista(tlista));
              break;
     case 3:  printf("Elemento da inserire ");
              scanf("%d",&x);
              in_lista(&tlista,x);
              break;
     case 4:  da_lista(&tlista);
              break;
     case 5:  visualizza(tlista);
              break;
     default:; }
  } while (scelta!=0);
  
  /* liberiamo la memoria occupata dalla lista*/
  while(tlista!=NULL)
    da_lista(&tlista);
}    
      
     
     
     
     



       
